package data.hullmods;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.impl.campaign.ids.Stats;
import com.fs.starfarer.api.impl.hullmods.CompromisedStructure;

public class dara_TemperamentalShield extends BaseHullMod {

	private static final float MALF_CHANCE = 0.1f;		// 10% chance per second
	private static final float MALF_FLUX_LEVEL = 0.5f;	// 50% flux

	
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {

		float effect = stats.getDynamic().getValue(Stats.DMOD_EFFECT_MULT);	// Multiplier for D-mod stats, from skill effects
		
		stats.getShieldMalfunctionChance().modifyFlat(id, (MALF_CHANCE * effect));
		stats.getShieldMalfunctionFluxLevel().modifyFlat(id, MALF_FLUX_LEVEL);

		CompromisedStructure.modifyCost(hullSize, stats, id);
	}
	
	public String getDescriptionParam(int index, HullSize hullSize, ShipAPI ship) {

		float effect = 1f;
		if (ship != null) effect = ship.getMutableStats().getDynamic().getValue(Stats.DMOD_EFFECT_MULT);
		
		if (index == 0) return "" + (int) (MALF_FLUX_LEVEL * 100f);
		if (index >= 1) return CompromisedStructure.getCostDescParam(index, 1);
		return null;
	}
}
