package data.scripts.hullmods;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.CombatEngineAPI;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.combat.ShipSystemAPI;
import com.fs.starfarer.api.combat.ShipSystemAPI.SystemState;

import com.fs.starfarer.api.util.IntervalUtil;

public class dara_ModuleSelfDestruct extends BaseHullMod {
    
        private final IntervalUtil checker = new IntervalUtil(0.5f, 0.5f);

	@Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {
		
	}
        
        @Override
        public void advanceInCombat(ShipAPI ship, float amount) {
		
            CombatEngineAPI engine = Global.getCombatEngine();
            if (engine.isPaused()) {	// If the game is paused, skip everything below this point.
                return;
            }
            if (!ship.isStationModule()) {  // If this ship is not a module, go away. Why are we here?
                return;
            }
            checker.advance(amount);	// Advance until the given interval has elapsed, then continue.

            if (checker.intervalElapsed()) {
                ShipAPI parent = null;
                ShipSystemAPI travel = null;
                SystemState travelState = SystemState.IDLE;
                
                if (ship.getParentStation() != null) {
                    parent = ship.getParentStation();
                    travel = parent.getTravelDrive();
                    travelState = travel.getState();
                } 
                if (parent.isRetreating() && travelState == SystemState.ACTIVE) {
                    //Global.getCombatEngine().removeEntity(ship);
                    ship.setHitpoints(0f);
                }
            }
        }
	
        @Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		return null;
	}
	


}



