package data.scripts.hullmods;

import java.util.List;
import java.util.HashMap;
import java.util.Map;

import com.fs.starfarer.api.combat.BaseHullMod;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.ShipAPI.HullSize;
import com.fs.starfarer.api.impl.campaign.ids.Stats;

public class dara_RepurposedBays extends BaseHullMod {

	public static final float CARGO_BONUS = 75f;		// +75 cargo space per deck
	public static final float MIN_CREW_DECREASE = 10f;	// -10 min crew required per deck
        public static final float MAINTENANCE_DECREASE = 2f;    // -2 supplies/month per deck

	private Map<String, Integer> SAVED_DATA = new HashMap<>();
	
        @Override
	public void applyEffectsBeforeShipCreation(HullSize hullSize, MutableShipStatsAPI stats, String id) {

		if (SAVED_DATA.get(id) != null) {
			int BAYS_TO_REMOVE = (int) SAVED_DATA.get(id);

			int CARGO_BONUS_NET = (int) (BAYS_TO_REMOVE * CARGO_BONUS);
			int MIN_CREW_DECREASE_NET = (int) (BAYS_TO_REMOVE * MIN_CREW_DECREASE);
                        int MAINTENANCE_DECREASE_NET = (int) (BAYS_TO_REMOVE * MAINTENANCE_DECREASE);

			stats.getCargoMod().modifyFlat(id, CARGO_BONUS_NET);
			stats.getMinCrewMod().modifyFlat(id, -MIN_CREW_DECREASE_NET);
                        stats.getSuppliesPerMonth().modifyFlat(id, -MAINTENANCE_DECREASE_NET);
			stats.getNumFighterBays().modifyFlat(id, -BAYS_TO_REMOVE);
		}

		//int CARGO_BONUS_NET = (int) (BAYS_TO_REMOVE * CARGO_BONUS);
		//int MIN_CREW_DECREASE_NET = (int) (BAYS_TO_REMOVE * MIN_CREW_DECREASE);

		//int CARGO_BONUS_NET = (int) (stats.getNumFighterBays().getBaseValue() * CARGO_BONUS);
		//int MIN_CREW_DECREASE_NET = (int) (stats.getNumFighterBays().getBaseValue() * MIN_CREW_DECREASE);
		//int BAYS_TO_REMOVE = (int) (stats.getNumFighterBays().getBaseValue());

		//stats.getCargoMod().modifyFlat(id, CARGO_BONUS_NET);
		//stats.getMinCrewMod().modifyFlat(id, -MIN_CREW_DECREASE_NET);
		//stats.getNumFighterBays().modifyFlat(id, -BAYS_TO_REMOVE);
	}

        @Override
	public void applyEffectsAfterShipCreation(ShipAPI ship, String id) {

		//int BAYS_TO_REMOVE = (int)ship.getMutableStats().getNumFighterBays().getBaseValue() - (ship.getVariant().getWings().size() - ship.getVariant().getNonBuiltInWings().size());
		int BAYS_TO_REMOVE = (int)ship.getMutableStats().getNumFighterBays().getBaseValue();
                BAYS_TO_REMOVE -= (int)ship.getHullSpec().getBuiltInWings().size();
                SAVED_DATA.put(id, BAYS_TO_REMOVE);

		//List<BuiltInWings> BUILT_IN_WINGS = ship.getVariant().getHullSpec().getBuiltInWings();
		//MutableShipStatsAPI stats = ship.getMutableStats();
		//int BAYS_TO_REMOVE = (int) (stats.getNumFighterBays().getBaseValue());

        	//int BAYS_TO_REMOVE = (int)ship.getMutableStats().getNumFighterBays().getBaseValue() - (ship.getVariant().getWings().size() - ship.getVariant().getNonBuiltInWings().size());
        	//ship.getMutableStats().getNumFighterBays().modifyFlat(id, -BAYS_TO_REMOVE);
	}
	
        @Override
	public String getDescriptionParam(int index, HullSize hullSize) {
		if (index == 0) return "modular";
		if (index == 1) return "each bay removed";
		if (index == 2) return "" + (int) CARGO_BONUS + "";
		if (index == 3) return "" + (int) MIN_CREW_DECREASE + "";
                if (index == 4) return "" + (int) MAINTENANCE_DECREASE + "";
                //if (index == 4) return "" + (int) BAYS_TO_REMOVE + "";
		return null;
	}
	
        @Override
	public boolean isApplicableToShip(ShipAPI ship) {
		int bays = (int) ship.getMutableStats().getNumFighterBays().getBaseValue();
		if (ship != null && ship.getVariant().getHullSpec().getBuiltInWings().size() == ship.getMutableStats().getNumFighterBays().getBaseValue()) {
			return false;
		}
		return ship != null && bays > 0; 
	}
	
        @Override
	public String getUnapplicableReason(ShipAPI ship) {
		if (ship != null && ship.getMutableStats().getNumFighterBays().getBaseValue() >= 1
                        && ship.getVariant().getHullSpec().getBuiltInWings().size() == ship.getMutableStats().getNumFighterBays().getBaseValue()) {
			return "Built-in fighter bays cannot be repurposed";
		}
		return "Ship does not have standard fighter bays";
	}
}




