package data.scripts.shipsystems;

import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;
import com.fs.starfarer.api.combat.ShipAPI;
import com.fs.starfarer.api.combat.WeaponAPI;
import com.fs.starfarer.api.combat.WeaponAPI.WeaponType;

import java.awt.Color;
import org.lazywizard.lazylib.VectorUtils;
import org.lwjgl.util.vector.Vector2f;

public class dara_DetonateStats extends BaseShipSystemScript {

	//public static final float ARMING_TIME = 1f;
        private static final Color COLOR = new Color(250,80,80,255);
        private static final float VISUAL_RADIUS = 150f;
        private static final Vector2f ZERO = new Vector2f();
	
        @Override
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {
            
                ShipAPI ship = null;
		if (stats.getEntity() instanceof ShipAPI) {
			ship = (ShipAPI) stats.getEntity();
		} else {
			return;
		}
                ship.getEngineController().forceFlameout();
                
                WeaponAPI source_wpn = null;
                if (state == State.OUT) {
                    for (WeaponAPI weapon : ship.getAllWeapons()) {
                        if (weapon.getType() == WeaponType.DECORATIVE) {
                            source_wpn = weapon;
                            // Get the source weapon that the second stage projectile will be spawned from.
                            // The Kamikaze Talon mounts a single decorative weapon we use for this.
                        }
                    }

                    //float spawnAngle = VectorUtils.getAngle(new Vector2f(), ship.getVelocity());
                    
                    Global.getCombatEngine().spawnProjectile(ship, source_wpn,
                                                    "dara_talonmissile_faux",
                                                    //"dara_droneexplosion_faux",
                                                    //"flak",
                                                    ship.getLocation(),
                                                    //spawnAngle,
                                                    ship.getFacing(),
                                                    ship.getVelocity());
                    Global.getCombatEngine().spawnExplosion(ship.getLocation(),
                                                    ship.getVelocity(),
                                                    COLOR,
                                                    120,
                                                    1.5f);
                    Global.getSoundPlayer().playSound("dara_nitro_eject", 
                                                    1f, 
                                                    1f, 
                                                    ship.getLocation(), 
                                                    ship.getVelocity());

                    Global.getCombatEngine().removeEntity(ship);
                }
	}
        
        @Override
	public void unapply(MutableShipStatsAPI stats, String id) {

	}
        
	@Override
	public StatusData getStatusData(int index, State state, float effectLevel) {
                if (index == 0) {
			return new StatusData("arming detonator...", true);
		}
		return null;
	}
}
