package data.scripts.shipsystems;

import com.fs.starfarer.api.combat.MutableShipStatsAPI;
import com.fs.starfarer.api.impl.combat.BaseShipSystemScript;

public class dara_TugDroneStats extends BaseShipSystemScript {

	public static final float HANDLING_BONUS_BASE = 5f;
	
	public void apply(MutableShipStatsAPI stats, String id, State state, float effectLevel) {

		float HANDLING_BONUS_TOTAL = HANDLING_BONUS_BASE * effectLevel;
		
		stats.getMaxSpeed().modifyPercent(id, HANDLING_BONUS_TOTAL);
		stats.getAcceleration().modifyPercent(id, HANDLING_BONUS_TOTAL);
		stats.getDeceleration().modifyPercent(id, HANDLING_BONUS_TOTAL);
		stats.getMaxTurnRate().modifyPercent(id, (HANDLING_BONUS_TOTAL * 5f));		// (5*4)*5 = 100%
		stats.getTurnAcceleration().modifyPercent(id, (HANDLING_BONUS_TOTAL * 5f));
	}
	public void unapply(MutableShipStatsAPI stats, String id) {

		stats.getMaxSpeed().unmodify(id);
		stats.getAcceleration().unmodify(id);
		stats.getDeceleration().unmodify(id);
		stats.getMaxTurnRate().unmodify(id);
		stats.getTurnAcceleration().unmodify(id);
	}
	
	public StatusData getStatusData(int index, State state, float effectLevel) {

		float HANDLING_BONUS_TOTAL = HANDLING_BONUS_BASE * effectLevel;

		if (index == 0) {
			return new StatusData("top speed +" + (int) HANDLING_BONUS_TOTAL + "%", false);
		} else if (index == 1) {
			return new StatusData("improved manoeuvrability", false);
		}
		return null;
	}
}
